'		File:			Launcher.vbs
'		Description:	Audit XenApp Farm Launching Utility Script
'		Requirements:	Run on XenApp Server
'		Created by:		Andy Paul
'						www.paultechnologies.com
'
'		Assumes C:\Program Files\XenAppTemp location but can be modified in code as needed.
'		For x64 systems, calls 32-bit processes for MSAccess Database accessability
'
'
on error resume next
xenappver = "ERROR"
Dim  progpath : progpath="C:\Program Files\XenAppAudit\"
'Get Program Path from actual execution location
curpath = Replace(WScript.ScriptFullName, WScript.ScriptName, "") 
Set wshShell = CreateObject( "WScript.Shell" )
Set objFSO = CreateObject("Scripting.FileSystemObject")
progpath = curpath

' Display the result
Dim resultspath :  resultspath=progpath & "Results"
Dim scriptspath : scriptspath=progpath & "Scripts"
varCloseOut = 0 
Set objFSO = CreateObject("Scripting.FileSystemObject")
strFilePath = resultspath & "\Transcript_Launcher.txt"
Set objResultsFile = objFSO.OpenTextFile(strFilePath, 8, True, 0)

objResultsFile.WriteLine "USER NAME       :  " & wshShell.ExpandEnvironmentStrings( "%USERNAME%" )
objResultsFile.WriteLine "COMPUTER NAME   :  " & wshShell.ExpandEnvironmentStrings( "%COMPUTERNAME%" )
objResultsFile.WriteLine "PROGRAM PATH    :  " & progpath
objResultsFile.WriteLine "DATE STAMP      :  " & Now()
objResultsFile.WriteLine "-----------------------------------------------"
dim filesys, xenappver
Set filesys = CreateObject("Scripting.FileSystemObject")

var64 =  wshShell.ExpandEnvironmentStrings( "%PROCESSOR_ARCHITECTURE%" )

if var64 = "AMD64" then
	objResultsFile.WriteLine "       ...  Running 64-bit Operating System"
	xenappver = filesys.GetFileVersion("c:\Program Files (x86)\Citrix\System32\wfshell.exe")	
else
	objResultsFile.WriteLine "       ...  Running 32-bit Operating System"
	xenappver = filesys.GetFileVersion("c:\Program Files\Citrix\System32\wfshell.exe")	
end if

if xenappver = "ERROR" then
	msgbox "ERROR: Unable to Determine XenApp Version. XenAppAudit is designed to be run on a XenAppServer.",vbCritical,"Unknown XenApp Version"
		objResultsFile.WriteLine "       .....Exiting due to error with XenApp Install..."
		varCloseOut = 1
end if
objResultsFile.WriteLine "-----------------------------------------------"
if varcloseout = 0 then  
	if var64 = "AMD64" then
		if left(xenappver,1) = 6 then
			objResultsFile.WriteLine "       ...  XenApp " & left(xenappver,3)
			if filesys.fileExists("C:\Program Files\Citrix\XenApp Server SDK\Citrix.XenApp.Sdk.ps1") then	
				objResultsFile.WriteLine "       ...  Launching PowerShell XenApp Collection"		
				objResultsFile.WriteLine "       ...  Transcript available under ..\Results\Transcript.txt"
				objResultsFile.WriteLine "       ...  PowerShell Script begin: " & now()
				cmdstr = "%SystemRoot%\syswow64\WindowsPowerShell\v1.0\powershell.exe -executionpolicy Unrestricted -file " & chr(34) & scriptspath & "\XenAppAudit.PS1" & chr(34)
				objResultsFile.WriteLine "       ..... Executing: " & cmdstr
				WshShell.Run cmdstr, 1, true
				objResultsFile.WriteLine "       ...  PowerShell Script complete: " & now()
			elseif filesys.fileExists("C:\Program Files\Citrix\XenApp 6.5 Server SDK\Citrix.XenApp.Sdk.ps1") then	
				objResultsFile.WriteLine "       ...  XenApp 6.5"
				objResultsFile.WriteLine "       ...  Launching PowerShell XenApp Collection"		
				objResultsFile.WriteLine "       ...  Transcript available under ..\Results\Transcript.txt"
				objResultsFile.WriteLine "       ...  PowerShell Script begin: " & now()
				cmdstr = "%SystemRoot%\syswow64\WindowsPowerShell\v1.0\powershell.exe -executionpolicy Unrestricted -file " & chr(34) & scriptspath & "\XenAppAudit.PS1" & chr(34)
				objResultsFile.WriteLine "       ..... Executing: " & cmdstr
				WshShell.Run cmdstr, 1, true
				objResultsFile.WriteLine "       ...  PowerShell Script complete: " & now()
			else
				msgbox "ERROR: Unable to find XenApp SDK. XenApp SDK is required for the XenApp Audit to run.",vbCritical,"XenApp 6 SDK Required."
				objResultsFile.WriteLine "       .....Exiting due to error with SDK..."
				varCloseOut = 1
			end if
		else
			objResultsFile.WriteLine "       ...  XenApp " & left(xenappver,3)
				objResultsFile.WriteLine "       ...  Launching VBScript/MFCOM XenApp Collection"		
				objResultsFile.WriteLine "       ...  Transcript available under ..\Results\Transcript.txt"
				objResultsFile.WriteLine "       ...  VBScript begin: " & now()
				cmdstr = "C:\Windows\SysWOW64\cscript.exe /NOLOGO " & chr(34) & scriptspath & "\XenAppAudit.wsf" & chr(34)
				objResultsFile.WriteLine "       ..... Executing: " & cmdstr
				WshShell.Run cmdstr, 1, true
				objResultsFile.WriteLine "       ...  VBScript complete: " & now()
		end if
	else
		if left(xenappver,1) = 6 then
			objResultsFile.WriteLine "       ...  ERROR: XenApp " & left(xenappver,3)
		else
			objResultsFile.WriteLine "       ...  XenApp " & left(xenappver,3)
				objResultsFile.WriteLine "       ...  Launching VBScript/MFCOM XenApp Collection"		
				objResultsFile.WriteLine "       ...  Transcript available under ..\Results\Transcript.txt"
				objResultsFile.WriteLine "       ...  VBScript begin: " & now()
				cmdstr = "C:\Windows\System32\cscript.exe /NOLOGO " & chr(34) & scriptspath & "\XenAppAudit.wsf" & chr(34)
				objResultsFile.WriteLine "       ..... Executing: " & cmdstr
				WshShell.Run cmdstr, 1, true
				objResultsFile.WriteLine "       ...  VBScript complete: " & now()
		end if
	end if
end if 

if varCloseOut = 0 then 
	strComputer = "."
	Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")        
	Set colOperatingSystems = objWMIService.ExecQuery _
        ("Select * from Win32_OperatingSystem")
	For Each objOperatingSystem in colOperatingSystems
		varOSName = objOperatingSystem.Caption 
		varOSNumber =  objOperatingSystem.Version
	Next

	call TextDataCollection

end if

'Close Out
CLOSEOUT:
objResultsFile.WriteLine "-----------------------------------------------"
objResultsFile.WriteLine "AUDIT COMPLETE  :  " & Now()
objResultsFile.Close
Set wshSystemEnv = Nothing
Set wshShell     = Nothing
wscript.quit
' *******************************************
sub TextDataCollection
'oShell.run "cmd /K CD C:\ & Dir"
'scriptspath
'resultspath
objResultsFile.WriteLine "-----------------------------------------------"
objResultsFile.WriteLine "ADDITIONAL DATA COLLECTION SCRIPTS"
objResultsFile.WriteLine "       ...  QFARM"
	cmdstr = "cmd.exe /C QFARM > " & chr(34) & resultspath & "\XenAppAudit_Data.txt" & chr(34)
	objResultsFile.WriteLine "       ..... Executing: " & cmdstr
	WshShell.Run cmdstr, 1, true
objResultsFile.WriteLine "       ...  QFARM /ZONE"
	cmdstr = "cmd.exe /C QFARM /ZONE >> " & chr(34) & resultspath & "\XenAppAudit_Data.txt" & chr(34)
	objResultsFile.WriteLine "       ..... Executing: " & cmdstr
	WshShell.Run cmdstr, 1, true
objResultsFile.WriteLine "       ...  QFARM /OFFLINE"
	cmdstr = "cmd.exe /C QFARM /OFFLINE >> " & chr(34) & resultspath & "\XenAppAudit_Data.txt" & chr(34)
	objResultsFile.WriteLine "       ..... Executing: " & cmdstr
	WshShell.Run cmdstr, 1, true
objResultsFile.WriteLine "       ...  QFARM /LOAD"
	cmdstr = "cmd.exe /C QFARM /LOAD > " & chr(34) & resultspath & "\QFARM_LOAD.txt" & chr(34)
	objResultsFile.WriteLine "       ..... Executing: " & cmdstr
	WshShell.Run cmdstr, 1, true
objResultsFile.WriteLine "       ...  QFARM /LTLOAD"
	if left(xenappver,3) = "4.0" then
		objResultsFile.WriteLine "       ..... Not applicable for Presentation Server 4"
	else
		cmdstr = "cmd.exe /C QFARM /LTLOAD > " & chr(34) & resultspath & "\QFARM_LTLOAD.txt" & chr(34)
		objResultsFile.WriteLine "       ..... Executing: " & cmdstr	
		WshShell.Run cmdstr, 1, true
	end if
objResultsFile.WriteLine "       ...  DSCHECK"
	cmdstr = "cmd.exe /C DSCHECK > " & chr(34) & resultspath & "\DSCheckResults.txt" & chr(34)
	objResultsFile.WriteLine "       ..... Executing: " & cmdstr
	WshShell.Run cmdstr, 1, true
objResultsFile.WriteLine "       ...  GPRESULT"
	if left(varOSNumber,1) >= 6 then 'Win2008+
		cmdstr = "cmd.exe /C GPRESULT /R > " & chr(34) & resultspath & "\GPResult.txt" & chr(34)
	else
		cmdstr = "cmd.exe /C GPRESULT > " & chr(34) & resultspath & "\GPResult.txt" & chr(34)
	end if
	objResultsFile.WriteLine "       ..... Executing: " & cmdstr
	WshShell.Run cmdstr, 1, true
objResultsFile.WriteLine "       ...  QUERYDS"
	objResultsFile.WriteLine "       ..... Run upon completion of all other scripts"
objResultsFile.WriteLine "       ...  DATASTORE"
	targetfile = resultspath & "\datastore.txt"
	filename = "C:\Program Files (x86)\Citrix\Independent Management Architecture\mf20.dsn"
		if filesys.fileExists(filename) then filesys.copyfile filename, targetfile
	filename = "C:\Program Files\Citrix\Independent Management Architecture\mf20.dsn"
		if filesys.fileExists(filename) then filesys.copyfile filename, targetfile
end sub